<template>
  <div>
    <img class="lantern-background" src="../assets/bg.png" alt="">
    <div class="content-frame" :class="{ 'margin-t-13' : countries.length > 0 }">
      <button class="btn btn-warning" @click="exportCovidDataPDF()" style="font-weight: bold">World Covid Data PDF</button>
      <img src="../assets/frame.png" alt="content-frame">
      <div class="row country-item-block">
        <div class="col-3" v-for="(item, index) in countries" :key="index">
          <div class="text-center glow" @click="exportCovidDataPDF(get(item, 'slug'))">
            <img
                style="width: 100%;height: 100%;max-width: 80px;max-height: 80px"
                :src="getFlagUrl(item)" :alt="get(item, 'slug')"
            >
            <p class="text-success mb-1" style="font-weight: bold">{{ get(item, 'name') }}</p>
            <p class="text-white mb-1" style="font-size: 12px;font-weight: bold">{{ getCurrency(item) }}</p>
            <p class="text-muted mb-2" style="font-size: 12px;font-weight: bold">{{ getLanguage(item) }}</p>
          </div>
        </div>
      </div>
      <div class="content-carousel">
        <img src="../assets/carousel.png" alt="content-carousel">
      </div>
      <div id="carouselIndicators" class="carousel slide content-carousel-frame" data-ride="carousel">
        <div class="carousel-inner">
          <div class="carousel-item" v-for="(item, index) in countries" :key="index" :class="{ active: index === 0 }">
            <img width="600" height="400" :src="get(item, 'flag')" :alt="get(item, 'slug')">
          </div>
        </div>
        <a class="carousel-control-prev" href="#carouselIndicators" role="button" data-slide="prev">
          <span class="carousel-control-prev-icon" aria-hidden="true"></span>
          <span class="sr-only">Previous</span>
        </a>
        <a class="carousel-control-next" href="#carouselIndicators" role="button" data-slide="next">
          <span class="carousel-control-next-icon" aria-hidden="true"></span>
          <span class="sr-only">Next</span>
        </a>
      </div>
    </div>
  </div>
</template>

<script>
import {countryApiUrl, exportApiUrl} from '../constants/config'
import axios from 'axios'
import { saveAs } from 'file-saver'
import { get } from 'lodash'

export default {
  name: 'LanternFestival',
  data () {
    return {
      get,
      countries: []
    }
  },
  created () {
    this.getCountryList()
  },
  methods: {
    async getCountryList () {
      const parameters = {
        'filters[min_population]': 300000,
        limit: 29
      }

      const response = await axios.get(`${countryApiUrl}/countries`, {params: parameters})
      const message = get(response, 'data.message')

      if (message.toUpperCase() === 'OK') {
        this.countries = get(response, 'data.data', [])
      } else {
        alert(message)
      }
    },
    async exportCovidDataPDF (slug = 'world') {
      await axios({
        url: `${exportApiUrl}/exports/covid-countries/${slug}`,
        method: 'GET',
        responseType: 'blob'
      }).then((response) => {
        saveAs(new Blob([response.data]), `covid-data-${slug}.pdf`)
      }).catch(_ => alert('No Content'))
    },
    getFlagUrl (country) {
      return `https://www.countryflags.io/${get(country, 'alpha2Code')}/flat/64.png`
    },
    getCurrency (country) {
      const currency = get(country, 'currencies.0')
      let symbolOrCode = get(currency, 'symbol', get(currency, 'code'))

      if (symbolOrCode) {
        symbolOrCode = `(${symbolOrCode}) `
      } else {
        symbolOrCode = ''
      }

      return `${symbolOrCode}${get(currency, 'name')}`
    },
    getLanguage (country) {
      const language = get(country, 'languages.0')
      let nativeName = get(language, 'nativeName')

      if (nativeName) {
        nativeName = `(${nativeName}) `
      } else {
        nativeName = ''
      }

      return `${nativeName}${get(language, 'name')}`
    }
  }
}
</script>

<style scoped>
.lantern-background {
  height: 100%;
}

.content-frame {
  position: absolute;
  left: 50%;
  transform: translate(-50%, -50%);
  transition: all .5s
}

.margin-t-13 {
  margin-top: 13rem;
}

.country-item-block {
  position: absolute;
  top: 10.7%;
  padding: 0 4rem 0 4rem;
  margin: 28px 0px;
  height: 1000px;
  overflow-y: scroll;
}

.content-carousel {
  position: absolute;
}

.content-carousel-frame {
  margin-top: 15.1rem;
  margin-right: 1.7rem;
  margin-left: auto;
  padding-left: 4rem;
  padding-right: 4rem;
}

.glow {
  transition: all .2s ease-in-out;
}

.glow:hover{
  cursor: pointer;
  transform: scale(1.1);
}
</style>
